diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CreateFeatureTreeHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CreateFeatureTreeHandler.java
index 4e8349a64..12930b929 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CreateFeatureTreeHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CreateFeatureTreeHandler.java
@@ -17,7 +17,8 @@ import org.eclipse.e4.ui.model.application.ui.basic.MPart;
 import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
 import org.eclipse.e4.ui.services.IServiceConstants;
 
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.featuretree.e4.operation.CreateFeatureTreeOperation;
@@ -39,7 +40,7 @@ public class CreateFeatureTreeHandler {
             return;
         }
 
-        FeatureTree tree = FeatureTree.NewInstance(getTermType());
+        TermTree<Feature> tree = TermTree.NewInstance(getTermType());
         tree.setTitleCache("New feature tree", true);
         CreateFeatureTreeOperation operation = new CreateFeatureTreeOperation(tree, editor, editor);
         AbstractUtility.executeOperation(operation, sync);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportOntologyHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportOntologyHandler.java
index 234158cfe..8a9f108ea 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportOntologyHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportOntologyHandler.java
@@ -28,7 +28,7 @@ import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.progress.IProgressConstants;
 
 import eu.etaxonomy.cdm.io.descriptive.owl.out.StructureTreeOwlExportConfigurator;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.preference.IPreferenceKeys;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
@@ -53,7 +53,7 @@ public class FeatureTreeExportOntologyHandler {
         }
 
         List<UUID> featureTreeUuids = new ArrayList<>();
-        selection.toList().stream().filter(o->o instanceof FeatureTree).forEach(tree->featureTreeUuids.add(((FeatureTree)tree).getUuid()));
+        selection.toList().stream().filter(o->o instanceof TermTree).forEach(tree->featureTreeUuids.add(((TermTree)tree).getUuid()));
 
         FileDialog dialog = new FileDialog(shell);
         String[] filterNames = {
@@ -90,7 +90,7 @@ public class FeatureTreeExportOntologyHandler {
         canExecute = PreferencesUtil.getBooleanValue(IPreferenceKeys.SHOW_EXPERIMENTAL_FEATURES)
                 && selection!=null
                 && selection.size()==1
-                && selection.getFirstElement() instanceof FeatureTree;
+                && selection.getFirstElement() instanceof TermTree;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportWordHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportWordHandler.java
index 872f64f20..45767758b 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportWordHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/FeatureTreeExportWordHandler.java
@@ -25,7 +25,8 @@ import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.progress.IProgressConstants;
 
 import eu.etaxonomy.cdm.io.descriptive.word.out.WordExportConfigurator;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.preference.IPreferenceKeys;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
@@ -49,7 +50,7 @@ public class FeatureTreeExportWordHandler {
             return;
         }
 
-        FeatureTree selectedFeatureTree = (FeatureTree) selection.getFirstElement();
+        TermTree<Feature> selectedFeatureTree = (TermTree<Feature>) selection.getFirstElement();
         DirectoryDialog dialog = new DirectoryDialog(shell);
         String directoryString = dialog.open();
         if(directoryString!=null){
@@ -71,7 +72,7 @@ public class FeatureTreeExportWordHandler {
         canExecute = PreferencesUtil.getBooleanValue(IPreferenceKeys.SHOW_EXPERIMENTAL_FEATURES)
                 && selection!=null
                 && selection.size()==1
-                && selection.getFirstElement() instanceof FeatureTree;
+                && selection.getFirstElement() instanceof TermTree;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/PasteFeatureHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/PasteFeatureHandler.java
index 0044cf1a9..636a74ebe 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/PasteFeatureHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/PasteFeatureHandler.java
@@ -13,7 +13,7 @@ import org.eclipse.jface.util.LocalSelectionTransfer;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.e4.FeatureTreeEditor;
 
 public class PasteFeatureHandler {
@@ -36,7 +36,7 @@ public class PasteFeatureHandler {
                 && selection.size()==1
                 && transferSelection instanceof IStructuredSelection
                 && ((IStructuredSelection)transferSelection).size()==1
-                && ((IStructuredSelection)transferSelection).getFirstElement() instanceof FeatureNode;
+                && ((IStructuredSelection)transferSelection).getFirstElement() instanceof TermNode;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureHandler.java
index 5d5a5c316..dd959da31 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureHandler.java
@@ -19,7 +19,8 @@ import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
 import org.eclipse.e4.ui.services.IServiceConstants;
 import org.eclipse.jface.viewers.IStructuredSelection;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.featuretree.e4.operation.RemoveFeatureOperation;
 import eu.etaxonomy.taxeditor.model.AbstractUtility;
@@ -45,7 +46,7 @@ public class RemoveFeatureHandler {
         }
 
         for (Object selectedObject : selection.toArray()) {
-            FeatureNode featureNode = (FeatureNode) selectedObject;
+        	TermNode<Feature> featureNode = (TermNode<Feature>) selectedObject;
             RemoveFeatureOperation operation = new RemoveFeatureOperation(featureNode, editor, editor);
             AbstractUtility.executeOperation(operation, sync);
         }
@@ -59,7 +60,7 @@ public class RemoveFeatureHandler {
         boolean canExecute = selection!=null && !selection.isEmpty();
         if(selection!=null){
             for(Object object:selection.toArray()){
-                canExecute &= object instanceof FeatureNode;
+                canExecute &= object instanceof TermNode;
             }
         }
         canExecute &= thisPart.getObject() instanceof IFeatureTreeEditor;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureTreeHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureTreeHandler.java
index b99616fa5..6c04da9e2 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureTreeHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/RemoveFeatureTreeHandler.java
@@ -19,7 +19,8 @@ import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
 import org.eclipse.e4.ui.services.IServiceConstants;
 import org.eclipse.jface.viewers.IStructuredSelection;
 
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.featuretree.e4.operation.RemoveFeatureTreeOperation;
 import eu.etaxonomy.taxeditor.model.AbstractUtility;
@@ -45,7 +46,7 @@ public class RemoveFeatureTreeHandler {
         }
 
         for (Object selectedObject : selection.toArray()) {
-            FeatureTree featureTree = (FeatureTree) selectedObject;
+        	TermTree<Feature> featureTree = (TermTree<Feature>) selectedObject;
             RemoveFeatureTreeOperation operation = new RemoveFeatureTreeOperation(featureTree, editor, editor);
             AbstractUtility.executeOperation(operation, sync);
         }
@@ -59,7 +60,7 @@ public class RemoveFeatureTreeHandler {
         boolean canExecute = selection!=null && !selection.isEmpty();
         if(canExecute){
             for(Object object:selection.toArray()){
-                canExecute &= object instanceof FeatureTree;
+                canExecute &= object instanceof TermTree;
             }
         }
         canExecute &= thisPart.getObject() instanceof IFeatureTreeEditor;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddFeatureOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddFeatureOperation.java
index 3f1b3d407..431277013 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddFeatureOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddFeatureOperation.java
@@ -18,7 +18,7 @@ import org.eclipse.core.runtime.IStatus;
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
 import eu.etaxonomy.cdm.api.service.UpdateResult;
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -32,15 +32,15 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
  */
 public class AddFeatureOperation extends AbstractPostOperation<Feature> {
 
-    private FeatureNode node;
+    private TermNode<Feature> node;
     private int position;
     private UUID featureUuid;
 
-    public AddFeatureOperation(UUID featureUuid, FeatureNode node,
+    public AddFeatureOperation(UUID featureUuid, TermNode<Feature> node,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         this(featureUuid, node, 0, postOperationEnabled, cdmEntitySessionEnabled);
     }
-    public AddFeatureOperation(UUID featureUuid, FeatureNode node, int position,
+    public AddFeatureOperation(UUID featureUuid, TermNode<Feature> node, int position,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super("Add Feature", StoreUtil.getUndoContext(), null, postOperationEnabled, cdmEntitySessionEnabled);
         this.node = node;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddOntologyTermOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddOntologyTermOperation.java
index 64dd5929f..ec7379246 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddOntologyTermOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/AddOntologyTermOperation.java
@@ -18,7 +18,7 @@ import org.eclipse.core.runtime.IStatus;
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
 import eu.etaxonomy.cdm.api.service.UpdateResult;
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
@@ -32,13 +32,13 @@ import eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper.OntologyTermWrap
  * @since Apr 30, 2018
  *
  */
-public class AddOntologyTermOperation extends AbstractPostOperation<FeatureNode> {
+public class AddOntologyTermOperation extends AbstractPostOperation<TermNode<Feature>> {
 
-    private FeatureNode target;
+    private TermNode<Feature> target;
     private OntologyTermWrapper wrapper;
     private TermVocabulary vocabulary;
 
-    public AddOntologyTermOperation(OntologyTermWrapper wrapper, FeatureNode target, TermVocabulary vocabulary,
+    public AddOntologyTermOperation(OntologyTermWrapper wrapper, TermNode<Feature> target, TermVocabulary vocabulary,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super("Add ontology term", StoreUtil.getUndoContext(), target, postOperationEnabled, cdmEntitySessionEnabled);
         this.wrapper = wrapper;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/CreateFeatureTreeOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/CreateFeatureTreeOperation.java
index 5a9d9cf7e..398960246 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/CreateFeatureTreeOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/CreateFeatureTreeOperation.java
@@ -14,7 +14,8 @@ import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
 
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -26,9 +27,9 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
  * @since Apr 30, 2018
  *
  */
-public class CreateFeatureTreeOperation extends AbstractPostOperation<FeatureTree>{
+public class CreateFeatureTreeOperation extends AbstractPostOperation<TermTree<Feature>>{
 
-    public CreateFeatureTreeOperation(FeatureTree element,
+    public CreateFeatureTreeOperation(TermTree<Feature> element,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super("Create Feature Tree", StoreUtil.getUndoContext(), element, postOperationEnabled, cdmEntitySessionEnabled);
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/MoveFeatureOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/MoveFeatureOperation.java
index fc744128d..a7086c453 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/MoveFeatureOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/MoveFeatureOperation.java
@@ -17,7 +17,8 @@ import org.eclipse.swt.dnd.DND;
 
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
 import eu.etaxonomy.cdm.api.service.UpdateResult;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -30,14 +31,14 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
  * @date 21.01.2019
  *
  */
-public class MoveFeatureOperation extends AbstractPostOperation<FeatureNode> {
+public class MoveFeatureOperation extends AbstractPostOperation<TermNode<Feature>> {
 
-    private FeatureNode droppedNode;
-    private FeatureNode target;
+    private TermNode<Feature> droppedNode;
+    private TermNode<Feature> target;
     private int currentOperation;
     private int position;
 
-    public MoveFeatureOperation(FeatureNode droppedNode, FeatureNode target, int position,
+    public MoveFeatureOperation(TermNode<Feature> droppedNode, TermNode<Feature> target, int position,
             int currentOperation,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super(currentOperation == DND.DROP_MOVE ? "Move Feature" : "Copy Feature", StoreUtil.getUndoContext(),
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureOperation.java
index e465c0119..c6af77f13 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureOperation.java
@@ -15,8 +15,9 @@ import org.eclipse.core.runtime.IStatus;
 
 import eu.etaxonomy.cdm.api.service.DeleteResult;
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
-import eu.etaxonomy.cdm.api.service.config.FeatureNodeDeletionConfigurator;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.api.service.config.TermNodeDeletionConfigurator;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -28,16 +29,16 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
  * @since Apr 30, 2018
  *
  */
-public class RemoveFeatureOperation extends AbstractPostOperation<FeatureNode>{
+public class RemoveFeatureOperation extends AbstractPostOperation<TermNode<Feature>>{
 
-    public RemoveFeatureOperation(FeatureNode element,
+    public RemoveFeatureOperation(TermNode<Feature> element,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super("Remove Feature", StoreUtil.getUndoContext(), element, postOperationEnabled, cdmEntitySessionEnabled);
     }
 
     @Override
     public IStatus execute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
-        DeleteResult result = CdmStore.getService(IFeatureNodeService.class).deleteFeatureNode(element.getUuid(), new FeatureNodeDeletionConfigurator());
+        DeleteResult result = CdmStore.getService(IFeatureNodeService.class).deleteFeatureNode(element.getUuid(), new TermNodeDeletionConfigurator());
         return postExecute(null);
     }
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureTreeOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureTreeOperation.java
index 286d8e577..8b29c8222 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureTreeOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/operation/RemoveFeatureTreeOperation.java
@@ -14,7 +14,8 @@ import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
 
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -26,9 +27,9 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
  * @since Apr 30, 2018
  *
  */
-public class RemoveFeatureTreeOperation extends AbstractPostOperation<FeatureTree>{
+public class RemoveFeatureTreeOperation extends AbstractPostOperation<TermTree<Feature>>{
 
-    public RemoveFeatureTreeOperation(FeatureTree element,
+    public RemoveFeatureTreeOperation(TermTree<Feature> element,
             IPostOperationEnabled postOperationEnabled, ICdmEntitySessionEnabled cdmEntitySessionEnabled) {
         super("Remove Feature Tree", StoreUtil.getUndoContext(), element, postOperationEnabled, cdmEntitySessionEnabled);
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/io/e4/out/owl/OwlTermExportWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/io/e4/out/owl/OwlTermExportWizardPage.java
index f0b982553..19a465a40 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/io/e4/out/owl/OwlTermExportWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/io/e4/out/owl/OwlTermExportWizardPage.java
@@ -24,7 +24,8 @@ import org.eclipse.swt.widgets.FileDialog;
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
 import eu.etaxonomy.cdm.api.service.IVocabularyService;
 import eu.etaxonomy.cdm.common.CdmUtils;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.persistence.dto.TermVocabularyDto;
 import eu.etaxonomy.taxeditor.store.CdmStore;
@@ -32,7 +33,6 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
 /**
  * @author pplitzner
  * @since May 23, 2019
- *
  */
 public class OwlTermExportWizardPage extends WizardPage {
 
@@ -58,7 +58,7 @@ public class OwlTermExportWizardPage extends WizardPage {
         composite.getSelectVocabularyComposite().getViewer().setInput(areaVocabularies);
         composite.getSelectVocabularyComposite().getViewer().addCheckStateListener(e->updateButtons());
 
-        List<FeatureTree> trees = CdmStore.getService(IFeatureTreeService.class).list(FeatureTree.class, null, null, null, null);
+        List<TermTree<Feature>> trees = (List)CdmStore.getService(IFeatureTreeService.class).list(TermTree.class, null, null, null, null);
         composite.getSelectFeatureTreeComposite().getViewer().setInput(trees);
         composite.getSelectFeatureTreeComposite().getViewer().addCheckStateListener(e->updateButtons());
 
@@ -99,8 +99,8 @@ public class OwlTermExportWizardPage extends WizardPage {
         List<UUID> selectedTrees = new ArrayList<>();
         Object[] checkedElements = composite.getSelectFeatureTreeComposite().getViewer().getCheckedElements();
         for (Object object : checkedElements) {
-            if(object instanceof FeatureTree) {
-                selectedTrees.add(((FeatureTree) object).getUuid());
+            if(object instanceof TermTree) {
+                selectedTrees.add(((TermTree) object).getUuid());
             }
         }
         return selectedTrees;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainer.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainer.java
index 6a5316169..e050bc2b0 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainer.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainer.java
@@ -16,9 +16,8 @@ import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
+import eu.etaxonomy.cdm.model.term.TermNode;
 
 /**
  * This class is a simple container to allow generation of a datastructure that
@@ -41,7 +40,7 @@ public class FeatureNodeContainer{
 
 
 
-	private FeatureNode<Feature> featureNode;
+	private TermNode<Feature> featureNode;
 	private List<FeatureNodeContainer> children = new ArrayList<FeatureNodeContainer>();
 	private List<DescriptionElementBase> descriptionElements = new ArrayList<DescriptionElementBase>();
 
@@ -64,11 +63,11 @@ public class FeatureNodeContainer{
 	 * @param description
 	 * @return
 	 */
-	protected void findLeaves(FeatureNode<Feature> featureNode) {
+	protected void findLeaves(TermNode<Feature> featureNode) {
 		if(featureNode.isLeaf()){
 			buildLeaf(featureNode);
 		}else{
-			for(FeatureNode<Feature> childNode : featureNode.getChildNodes()){
+			for(TermNode<Feature> childNode : featureNode.getChildNodes()){
 				findLeaves(childNode);
 			}
 		}
@@ -80,7 +79,7 @@ public class FeatureNodeContainer{
 	 * @param description
 	 * @return
 	 */
-	private void buildLeaf(FeatureNode<Feature> featureNode){
+	private void buildLeaf(TermNode<Feature> featureNode){
 		if(featureNode.getTerm() == null){
 			throw new IllegalArgumentException("The given feature node does not have a feature.");
 		}
@@ -140,7 +139,7 @@ public class FeatureNodeContainer{
 	 */
 	private void buildBranch(){
 		if(getParent() == null){
-			FeatureNode<Feature> parentFeatureNode = getFeatureNode().getParent();
+			TermNode<Feature> parentFeatureNode = getFeatureNode().getParent();
 
 			if(parentFeatureNode.isRoot()){
 				containerTree.getRoot().addChild(this);
@@ -277,7 +276,7 @@ public class FeatureNodeContainer{
 	 *
 	 * @param featureNode a {@link eu.etaxonomy.cdm.model.term.FeatureNode} object.
 	 */
-	public void setFeatureNode(FeatureNode<Feature> featureNode) {
+	public void setFeatureNode(TermNode<Feature> featureNode) {
 		this.featureNode = featureNode;
 	}
 
@@ -286,7 +285,7 @@ public class FeatureNodeContainer{
 	 *
 	 * @return a {@link eu.etaxonomy.cdm.model.term.FeatureNode} object.
 	 */
-	public FeatureNode<Feature> getFeatureNode() {
+	public TermNode<Feature> getFeatureNode() {
 		return featureNode;
 	}
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainerTree.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainerTree.java
index 5c4adf19e..35cd77359 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainerTree.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/FeatureNodeContainerTree.java
@@ -20,14 +20,13 @@ import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 
 /**
  * @author n.hoffmann
  * @created Dec 2, 2010
- * @version 1.0
  */
 public class FeatureNodeContainerTree {
 
@@ -48,13 +47,13 @@ public class FeatureNodeContainerTree {
 		}
 	};
 
-	private Set<FeatureNodeContainer> featureNodeContainers = new HashSet<FeatureNodeContainer>();
+	private Set<FeatureNodeContainer> featureNodeContainers = new HashSet<>();
 
 	private FeatureNodeContainer root;
 	private DescriptionBase description;
-	private FeatureTree featureTree;
+	private TermTree<Feature> featureTree;
 
-	public FeatureNodeContainerTree(DescriptionBase description, FeatureTree featureTree){
+	public FeatureNodeContainerTree(DescriptionBase description, TermTree<Feature> featureTree){
 		this.description = description;
 		this.featureTree = featureTree;
 
@@ -69,13 +68,13 @@ public class FeatureNodeContainerTree {
 	 * or null if there are no elements.
 	 */
 	public void buildTree(){
-		List<FeatureNode> children = featureTree.getRootChildren();
+		List<TermNode<Feature>> children = featureTree.getRootChildren();
 
 //		if(description.getElements().isEmpty()){
 //			return;
 //		}
 
-		for(FeatureNode featureNode : children){
+		for(TermNode<Feature> featureNode : children){
 			root.findLeaves(featureNode);
 		}
 	}
@@ -138,7 +137,7 @@ public class FeatureNodeContainerTree {
 		return null;
 	}
 
-	public FeatureNodeContainer getFeatureNodeContainer(FeatureNode featureNode){
+	public FeatureNodeContainer getFeatureNodeContainer(TermNode<Feature> featureNode){
 		List<FeatureNodeContainer> leafs = root.getLeafs();
 
 		for(FeatureNodeContainer container : leafs){
@@ -168,7 +167,7 @@ public class FeatureNodeContainerTree {
 		return description;
 	}
 
-	public FeatureTree getFeatureTree() {
+	public TermTree<Feature> getFeatureTree() {
 		return featureTree;
 	}
 
